/*
    <one line to give the program's name and a brief idea of what it does.>
    Copyright (C) <year>  <name of author>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License along
    with this program; if not, write to the Free Software Foundation, Inc.,
    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
*/


#ifndef GOOGLEREADERCONNECTION_H
#define GOOGLEREADERCONNECTION_H

#include <KIO/Job>

#include <QLatin1String>
#include <QString>
#include <QByteArray>
#include <QVariant>

class GooglereaderConnection : public QObject
{
  Q_OBJECT

public:
    GooglereaderConnection( QObject *parent = 0 );
    void setUsername(QString user) { m_mail = user; }
    void setPassword(QString password) { m_pass = password; }
    void login();

    QString username() { return m_mail; }
    QString password() { return m_pass; }
    QByteArray authorization() { return m_auth; }
    QString token() { return QLatin1String(m_token); }
    QString userid() { return m_uid; }

private:
  void getSID();
  void getToken();
  void getUserdata();
  
  QVariant _getCookie();

  bool m_connected;
  bool m_isConnecting;
  bool m_activeJob;
  QString m_mail;
  QString m_pass;
  QString m_uid;
  QByteArray m_sid;
  QByteArray m_auth;
  QByteArray m_token;

signals:
  void loggedIn();

private slots:
  void slotSidData( KIO::Job *job, const QByteArray& data );
  void slotSidResult( KJob *job );

  void slotTokenData( KIO::Job *job, const QByteArray& data );
  void slotTokenResult( KJob *job );

  void slotUserResult( KJob *job );
};

#endif // GOOGLEREADERCONNECTION_H
